/*
 * curllib.h
 *
 * Copyright 2016 Michael Rasmussen <mir@datanom.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 */

#ifndef __CURLLIB_H__
#define __CURLLIB_H__

#include <glib.h>

G_BEGIN_DECLS

typedef enum {
	DELETE,
	GET,
	PROPFIND,
	PUT,
	REPORT,
	OPTIONS,
	LOCK,
	UNLOCK,
} RequestType;

typedef struct {
	RequestType request;
	GSList* headers;
	gchar* data;
	gchar* username;
	gchar* password;
	gchar* url;
} Request;

typedef struct {
	gint status;
	GSList* headers;
	gchar* data;
} Response;

Request* request_new();
void request_free(Request* request);
Response* request_send(Request* request, gboolean debug);
void response_free(Response* response);

G_END_DECLS

#endif

