/*
 * xml.h
 *
 * Copyright 2017 Michael Rasmussen <mir@datanom.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 */

#ifndef __XML_H__
#define __XML_H__

#include <glib.h>
#include <libxml/parser.h>
#include "caldav.h"

G_BEGIN_DECLS

GSList* find_element(const gchar* element, const gchar* xml, const gchar* prefix, const gchar* ns_url);
xmlNodePtr find_node_by_name(xmlNodePtr rootnode, const xmlChar* nodename, GSList** nodes);
GSList* find_node(const gchar* node, const gchar* xml);
GSList* find_calendars(const gchar* host_part, const gchar* xml);
void dump_node(FILE* f, xmlDocPtr doc, xmlNodePtr node);
void dump_nodes(gpointer data, gpointer user_data);
void get_props(gpointer data, gpointer user_data);
void set_debug_mode(gboolean mode);

G_END_DECLS

#endif
